.model small
.stack
.data

;o byte de saida da porta paralela (7-0): [7][6][5][4][3][sirene][ledGreen][ledRed]

;saidas:

fechado_out equ 00000001b	
aberto_out equ 00000010b
movimento_out equ 00000101b

;entradas:

abrir_in_Fechado   	equ	11101110b
abrir_in_Movimento 	equ 	10101110b
fechar_in_Aberto   	equ 	00001110b
fechar_in_Movimento	equ 	10001110b
aberto_in 	   	equ 	00101110b
fechado_in 	   	equ 	11001110b

arquivo db "log.txt","$"
manipulador dw ?

quebraLinha DB 13, 10
lenVel equ $ - offset strEstFechando 
len equ $ - offset quebraLinha

strEstFechado db  "estado_fechado ", "$" 
strEstFechando db "estado_fechando","$"
strEstAberto db   "estado_aberto  ", "$"
strEstAbrindo db  "estado_abrindo ","$"

imprimir MACRO string
mov ah, 9
lea dx, string
int 21h

ENDM

TestaFinaliza MACRO

push ax
mov dx,379h
in al,dx
and al, 00010000b
cmp al, 00010000b
pop ax
je FinalizaPrograma

ENDM


.code
.startup

inicio:

call criararquivo

;zerando a protoboard
mov al,0
mov dx,378h
out dx,al


estado_fechado:			;estado_fechado  o portao fechado

	mov al,fechado_out
	mov dx,378h
        out dx,al

        lea dx,strEstFechado
        call escrevearquivo
        
	imprimir strEstFechado

	loopestadofechado:

	TestaFinaliza 

	mov dx,379h
	in al,dx
	cmp al, abrir_in_Fechado
	jne loopestadofechado
      jmp estado_abrindo

estado_fechando:

      lea dx, strEstFechando
	call escrevearquivo

	mov dx,378h
	mov al,movimento_out
	out dx,al

	imprimir strEstFechando

	loopestadofechando:

	TestaFinaliza 

	mov dx, 379h
	in al,dx
	cmp al, abrir_in_Movimento
	je estado_abrindo
	cmp al, fechado_in
        je estado_fechado
	jne loopestadofechando


FinalizaPrograma:
	mov dx,378h
	mov al,0
	out dx,al
	mov ax,4c00h
	int 21h


estado_abrindo:

        lea dx,strEstAbrindo
        call escrevearquivo

	mov dx,378h
	mov al,movimento_out
	out dx,al
        xor dx, dx
        imprimir strEstAbrindo

	loopestadoabrindo:

	TestaFinaliza 

	mov dx, 379h
	in al,dx
	cmp al, fechar_in_Movimento
	je estado_fechando
	cmp al, aberto_in
	jne loopestadoabrindo


estado_aberto:

	mov dx,378h
	mov al,aberto_out
	out dx,al

      lea dx,strEstAberto
      call escrevearquivo

	imprimir strEstAberto

	loopestadoaberto:

	TestaFinaliza 
	
	mov dx,379h
	in al,dx
	cmp al,fechar_in_Aberto
	jne loopestadoaberto
        jmp estado_fechando





criararquivo proc
  

	mov ah,3Ch              ;Funo 3Ch (int 21h)
	mov cx,20h              ;Atributo (arquvio = 1)
	mov dx,offset(arquivo)  ;Offset do nome do arquivo (em ASCIIZ)
	int 21h                 ;Cria
	mov manipulador,ax 	;Salva o manipulador
	ret
endp criararquivo

abrirarquivo proc

	mov ah,3dh
	mov al,2; leitura e escrita
	mov dx,seg arquivo
	mov ds,dx
	lea dx,arquivo
	int 21h
	mov manipulador,ax
	ret
endp abrirarquivo

escrevearquivo PROC
                       
			mov ax,manipulador	;coloca o manipulador em ax
			mov bx,ax               ;manipulador em BX
			mov ah,40h              
                  mov cx,15d              ;Numero de bytes a escrever: 15
			int 21h                 ;Escreve
			mov ah, 40h
			mov cx, len
			lea dx, quebraLinha
			int 21h               
			RET

endp escrevearquivo
                        




.exit

end
